#!/bin/bash
# grab the most recent tag from and create archive out of it

# check if git is installed
git --version &> /dev/null
retval=$?
if [[ "$retval" -ne 0 ]] ; then
	echo "git: command not found"
	exit 1
fi

gzip --version &> /dev/null
retval=$?
if [[ "$retval" -ne 0 ]] ; then
        echo "gzip: command not found"
        exit 1
fi

# check if current tree can be described
git describe &> /dev/null
retval=$?
if [[ "$retval" -ne 0 ]] ; then 
	echo "git cannot describe current tree"
	exit 1
fi

# setup some variables
prefix="jhears-"
suffix="-src"
version=$(git describe)
name="$prefix$version$suffix"

# remove existing archives
rm -vf $prefix*$suffix.tar.gz

# create an archive
git archive --prefix="$name" "$version" | gzip > "$name".tar.gz
