/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.web.rs;

import org.codehaus.jackson.annotate.JsonCreator;
import org.codehaus.jackson.annotate.JsonProperty;

/**
 * Encapsulates audio entity identifier and fingerprint for sending to server.
 * 
 */
public class InsertRequest {

	private final String audioEntityId;

	private final String fingerprint;

	@JsonCreator
	public InsertRequest(@JsonProperty("audioEntityId") String audioEntityId,
			@JsonProperty("fingerprint") String fingerprint) {
		this.audioEntityId = audioEntityId;
		this.fingerprint = fingerprint;
	}

	public String getAudioEntityId() {
		return audioEntityId;
	}

	public String getFingerprint() {
		return fingerprint;
	}

	@Override
	public String toString() {
		return InsertRequest.class.getSimpleName() + " [audioEntityId="
				+ audioEntityId + ", fingerprint=" + fingerprint + "]";
	}

}
