/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.web.rs;

import java.io.Serializable;
import java.util.List;

import org.codehaus.jackson.annotate.JsonCreator;
import org.codehaus.jackson.annotate.JsonProperty;

//TODO javadoc
public class Match implements Serializable {

	private static final long serialVersionUID = 6623528718890154229L;

	private final String fingerprintId;

	private final List<RepeatCluster> repeatClusters;

	private final List<Repeat> repeats;

	private final List<SegmentCluster> segmentClusters;

	private final List<Segment> segments;

	@JsonCreator
	public Match(
			@JsonProperty("fingerprintId") String fingerprintId,
			@JsonProperty("segmentClusters") List<SegmentCluster> segmentClusters,
			@JsonProperty("segments") List<Segment> segments,
			@JsonProperty("repeatClusters") List<RepeatCluster> repeatClusters,
			@JsonProperty("repeats") List<Repeat> repeats) {
		this.fingerprintId = fingerprintId;
		this.segmentClusters = segmentClusters;
		this.segments = segments;
		this.repeatClusters = repeatClusters;
		this.repeats = repeats;
	}

	public String getFingerprintId() {
		return fingerprintId;
	}

	public List<RepeatCluster> getRepeatClusters() {
		return repeatClusters;
	}

	public List<Repeat> getRepeats() {
		return repeats;
	}

	public List<SegmentCluster> getSegmentClusters() {
		return segmentClusters;
	}

	public List<Segment> getSegments() {
		return segments;
	}

	@Override
	public String toString() {
		return Match.class.getSimpleName() + " [fingerprintId=" + fingerprintId
				+ ", repeatClusters=" + repeatClusters + ", repeats=" + repeats
				+ ", segmentClusters=" + segmentClusters + ", segments="
				+ segments + "]";
	}

}
