/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.web.rs;

import java.io.Serializable;
import java.util.Set;

import org.codehaus.jackson.annotate.JsonCreator;
import org.codehaus.jackson.annotate.JsonProperty;

//TODO javadoc
public class SearchResult implements Serializable {

	private static final long serialVersionUID = 7322806068163932510L;

	private final String audioEntityId;

	private final Set<Match> matches;

	@JsonCreator
	public SearchResult(@JsonProperty("audioEntityId") String audioEntityId,
			@JsonProperty("matches") Set<Match> matches) {
		this.audioEntityId = audioEntityId;
		this.matches = matches;
	}

	public String getAudioEntityId() {
		return audioEntityId;
	}

	public Set<Match> getMatches() {
		return matches;
	}

	@Override
	public String toString() {
		return SearchResult.class.getSimpleName() + " [audioEntityId="
				+ audioEntityId + ", matches=" + matches + "]";
	}

}
