/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.filter.newbloom;

import java.io.File;

import org.jhears.bitarray.CountingFileBitArray;
import org.jhears.bitarray.IBitArray;
import org.jhears.filter.bloom.AbstractBFState;

public class FcbaBFState extends AbstractBFState {

	private static final long serialVersionUID = 1371007303269062601L;

	private final CountingFileBitArray arr;

	public FcbaBFState(int m, int k, File file) {
		super(m, k);
		this.arr = new CountingFileBitArray(m * k, file);
	}

	@Override
	public long filterSize() {
		return arr.size();
	}

	@Override
	public IBitArray getBitArray() {
		return arr;
	}

	@Override
	public boolean supportsRemove() {
		return true;
	}

	@Override
	public String toString() {
		return FcbaBFState.class.getSimpleName() + " [arr=" + arr + ", super="
				+ super.toString() + "]";
	}
}
