/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.bitarray;

import java.io.File;
import java.io.IOException;

import org.jhears.util.RuntimeIOException;
import org.junit.Rule;
import org.junit.rules.TemporaryFolder;

public class CountingFileBitArrayTest extends ICountingBitArrayTest {

	@Rule
	public TemporaryFolder folder = new TemporaryFolder();

	int i = 0;

	@Override
	protected ICountingBitArray getBitArray(int capacity) {
		File file;
		try {
			file = folder.newFile(FileBitArrayTest.class.getSimpleName() + "-"
					+ Integer.toString(i++));
		} catch (IOException e) {
			throw new RuntimeIOException(e);
		}
		CountingFileBitArray arr = new CountingFileBitArray(capacity, file);
		arr.clear();
		return arr;
	}

}
