/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.bitarray;

import java.io.File;
import java.io.IOException;

import org.jhears.util.RuntimeIOException;
import org.junit.Rule;
import org.junit.rules.TemporaryFolder;

public class FileBitArrayTest extends IBitArrayTest {

	@Rule
	public TemporaryFolder folder = new TemporaryFolder();

	int i = 0;

	@Override
	protected IBitArray getBitArray(int capacity) {
		File file;
		try {
			file = folder.newFile(FileBitArrayTest.class.getSimpleName() + "-"
					+ Integer.toString(i++));
		} catch (IOException e) {
			throw new RuntimeIOException(e);
		}
		FileBitArray arr = new FileBitArray(capacity, file);
		arr.clear();
		return arr;
	}

	@Override
	protected int[] getCapacities() {
		return new int[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 30, 31, 32, 33, 34, 60,
				61, 62, 63, 64, 65, 66, 67, 68, 69, 125, 126, 127, 128, 129,
				130, 131, 132, 253, 254, 255 };
	}
}
