/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.crypto;

import java.nio.charset.Charset;

import junit.framework.Assert;

import org.junit.Test;

public class AuthCodeTest {

	private static final Charset cs = Charset.forName("US-ASCII");

	@Test
	public void test() {
		String expected = "c1b2fa3b50c4f78ed8e5e8ae2683101a8b2edd922e9c5bf1522b6ff2fbd9152b2de6afea0913635851e7203f08959fe09328c8be860925acde02499c9fed27f3";
		AuthCode authCode = new AuthCode();
		byte[] salt = "salt".getBytes(cs);
		byte[] password = "password".getBytes(cs);
		byte[] hash = authCode.calculate(salt, password);
		Assert.assertEquals(expected, new String(Hex.encodeHex(hash)));
		// sequential calls must produce the same value
		salt = "salt".getBytes(cs);
		password = "password".getBytes(cs);
		hash = authCode.calculate(salt, password);
		Assert.assertEquals(expected, new String(Hex.encodeHex(hash)));
	}

}
