/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.crypto;

import java.nio.charset.Charset;

import junit.framework.Assert;

import org.junit.Test;

public class HMacImplTest {
	private static final Charset cs = Charset.forName("US-ASCII");

	@Test
	public void test() {
		String expected = "1bba587c730eedba31f53abb0b6ca589e09de4e894ee455e6140807399759adaafa069eec7c01647bb173dcb17f55d22af49a18071b748c5c2edd7f7a829c632";
		HMacImpl hmac = new HMacImpl();
		byte[] key = "secret".getBytes(cs);
		byte[] message = "message".getBytes(cs);
		byte[] hash = hmac.hmac(key, message);
		Assert.assertEquals(expected, new String(Hex.encodeHex(hash)));
		// successive calls must produce the same result
		key = "secret".getBytes(cs);
		message = "message".getBytes(cs);
		hash = hmac.hmac(key, message);
		Assert.assertEquals(expected, new String(Hex.encodeHex(hash)));
	}

}
