/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.filter.bloom.scalable;

import org.jhears.filter.bloom.Hasher;
import org.jhears.filter.bloom.IHasher;
import org.jhears.filter.bloom.scalable.BitArraySBFState;
import org.jhears.filter.bloom.scalable.IScalableBloomFilter;
import org.jhears.filter.bloom.scalable.IScalableBloomFilterState;
import org.jhears.filter.bloom.scalable.ScalableBloomFilter;
import org.jhears.filter.bloom.scalable.HVScalableBloomFilter;
import org.jhears.util.DefaultHashFunction;
import org.jhears.util.HashFunction;
import org.jhears.util.LCG;

public class ScalableBloomFilterTest extends AbstractScalableBloomFilterTest {

	@Override
	protected IScalableBloomFilter<Long> createFilter(int size, double p0,
			double r, int s, int m0) {
		IScalableBloomFilterState state = new BitArraySBFState(s, r, m0, p0);
		HVScalableBloomFilter alg = new HVScalableBloomFilter(state);
		HashFunction<Object> genericHash = new DefaultHashFunction<Object>();
		IHasher hasher = new Hasher(genericHash, new LCG());
		return new ScalableBloomFilter<Long>(alg, hasher);
	}

}
