/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.cluster;

import org.jhears.util.IntArr;

/**
 * Contains indexes of an array which form a cluster.
 */
public class Cluster extends IntArr {

	private static final long serialVersionUID = -7798496673539060346L;

	public Cluster(final int[] indexes) {
		super(indexes);
	}

	/**
	 * Represents input array indexes which forms this cluster.
	 * <p>
	 * Returns exactly the same object as {@link #getIntArr()}.
	 * 
	 * @return
	 */
	public int[] getIndexes() {
		return super.getIntArr();
	}

}