/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.exec;

import java.io.InputStream;
import java.io.OutputStream;

import org.apache.commons.exec.PumpStreamHandler;

/**
 * Closes output streams always when the input stream is exhausted.
 */
public class ClosePumpStreamHandler extends PumpStreamHandler {

	public ClosePumpStreamHandler() {
		super();
	}

	public ClosePumpStreamHandler(OutputStream outAndErr) {
		super(outAndErr);
	}

	public ClosePumpStreamHandler(OutputStream out, OutputStream err) {
		super(out, err);
	}

	public ClosePumpStreamHandler(OutputStream out, OutputStream err,
			InputStream input) {
		super(out, err, input);
	}

	@Override
	protected Thread createPump(InputStream is, OutputStream os) {
		return super.createPump(is, os, true);
	}

}
