/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.file;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.apache.commons.io.DirectoryWalker;
import org.apache.commons.io.filefilter.IOFileFilter;

/**
 * Walks directory tree recursively.
 */
public class SimpleDirWalker extends DirectoryWalker {

	private long count;

	public SimpleDirWalker(IOFileFilter filter) {
		super(null, filter, -1);
	}

	public long countFiles(File file) throws IOException {
		count = 0;
		walk(file, null);
		return count;
	}

	public List<File> getFiles(File file) throws IOException {
		ArrayList<File> list = new ArrayList<File>();
		walk(file, list);
		return list;
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	@Override
	protected void handleFile(File file, int depth, Collection results)
			throws IOException {
		if (results != null) {
			results.add(file);
		} else {
			count++;
		}
	}

}
