/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.logging;

import java.util.logging.Handler;
import java.util.logging.LogManager;

import org.slf4j.bridge.SLF4JBridgeHandler;

public class JulSlf4jBridge {

	/**
	 * If {@link LogManager} has {@link SLF4JBridgeHandler} then this method
	 * does noting. Otherwise this method will remove <b>all</b> {@link Handler}
	 * s and installs {@link SLF4JBridgeHandler}.
	 */
	public static synchronized void install() {
		boolean configured = false;
		for (Handler handler : LogManager.getLogManager().getLogger("")
				.getHandlers()) {
			if (handler instanceof SLF4JBridgeHandler) {
				configured = true;
				break;
			}
		}
		if (!configured) {
			for (Handler handler : LogManager.getLogManager().getLogger("")
					.getHandlers()) {
				LogManager.getLogManager().getLogger("").removeHandler(handler);
			}
			org.slf4j.bridge.SLF4JBridgeHandler.install();
		}
	}

}
