/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.logging;

import java.io.IOException;

import org.jhears.logging.OutputStreamLogger.Level;
import org.slf4j.Logger;

/**
 * Convenience class to create instances of {@link OutputStreamLogger}.
 */
public class OutStrLogFactory {

	public OutStrLogFactory() {
	}

	public OutputStreamLogger getOutputStreamLogger(Logger log, Level level)
			throws IOException {
		String name = name(log, level);
		OutputStreamLogger osl = new OutputStreamLogger(log, level);
		Thread t = new Thread(osl, name);
		// t.setDaemon(true);
		t.start();
		return osl;
	}

	private String name(Logger log, Level level) {
		StringBuilder sb = new StringBuilder();
		sb.append(log.getName());
		sb.append('-');
		sb.append(level.toString());
		return sb.toString();
	}

}
