/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.security;

import java.util.regex.Pattern;

public class StrUtil {

	private static final Pattern p = Pattern.compile("\\p{Cntrl}");

	/**
	 * Removes all control characters from string. Finally the string is trimmed
	 * (whitespace removed from beginning and from end).
	 * <p>
	 * Short hand for: String.replaceAll("\\p{Cntrl}", "").trim().
	 * 
	 * @param value
	 * @return sanitized string
	 */
	public static String sanitize(String value) {
		return p.matcher(value).replaceAll("").trim();
	}

}
