/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.pipe;

import java.io.IOException;

import org.apache.commons.io.IOUtils;

import com.google.common.base.Throwables;

public class PipePumpper implements Runnable {

	private final Pipe pipe;

	public PipePumpper(Pipe pipe) {
		this.pipe = pipe;
	}

	public void pump() throws IOException {
		IOUtils.copy(pipe.getIn(), pipe.getOut());
		pipe.getIn().close();
		pipe.getOut().flush();
		pipe.getOut().close();
	}

	@Override
	public void run() {
		try {
			pump();
		} catch (IOException e) {
			throw Throwables.propagate(e);
		}
	}

}
