/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.sample;

import java.util.Arrays;

import org.junit.Test;

import junit.framework.Assert;

public class InplaceHannWindowFunctionTest {

	@Test
	public void testApply() {
		InplaceHannWindowFunction f = new InplaceHannWindowFunction(16);
		double[] from = new double[16];
		double value = 10.0;
		Arrays.fill(from, value);
		f.apply(from);		
		Assert.assertEquals(from[0], 0.0, 0.01);
		Assert.assertEquals(value, from[from.length / 2], 0.2);
		Assert.assertEquals(from[from.length - 1], 0.0, 0.01);
	}
	
	@Test(expected = IllegalArgumentException.class)
	public void testWrongSizeArg() {
		new InplaceHannWindowFunction(16).apply(new double[17]);
	}
	
	@Test(expected = IllegalArgumentException.class)
	public void testInvalidConstructor() {
		new InplaceHannWindowFunction(0);
	}
	
}
