/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.sample;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.ShortBuffer;

import org.junit.Assert;
import org.junit.Test;

public class RawToSampleFunctionTest {

	@Test
	public void test() {
		int sampleWindowInSamples = 5;
		RawToSampleFunction f = new RawToSampleFunction(sampleWindowInSamples,
				ByteOrder.BIG_ENDIAN);
		byte[] array = new byte[sampleWindowInSamples * 2];
		ShortBuffer sb = ByteBuffer.wrap(array).asShortBuffer();
		sb.put((short) -1);
		sb.put((short) 1);
		sb.put((short) 0);
		sb.put(Short.MAX_VALUE);
		sb.put(Short.MIN_VALUE);
		double[] sample = f.apply(array);
		double[] expecteds = new double[] { -1.0 / (1 << 15), 1.0 / (1 << 15),
				0, 1.0, -1.0 };
		Assert.assertArrayEquals(expecteds, sample, 0.001);

	}

}
