/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.sample;

import org.junit.Assert;
import org.junit.Test;

public class SampleUtilTest {

	@Test
	public void testRms() {
		int samplelen = 8192;
		double freq = 64.0;
		double[] sample = new double[samplelen];
		for (int i = 0; i < samplelen; i++) {
			double value = Math.sin(2.0 * Math.PI * freq * i / samplelen);
			sample[i] = value;
		}
		SampleToPowerSpectrumFunction f = new SampleToPowerSpectrumFunction();
		double[] powspect = f.apply(sample);

		double sampleRms = SampleUtil.rms(sample);
		double powRms = SampleUtil.rmsFreqDomain(powspect);
		// System.out.println(sampleRms);
		// System.out.println(powRms);
		// System.out.println(Mth.sum(powspect));
		// Mth.div(sample, 2);
		// powspect = f.apply(sample);
		//
		// sampleRms = SampleUtil.rms(sample);
		// powRms = SampleUtil.rmsFreqDomain(powspect);
		// System.out.println(sampleRms);
		// System.out.println(powRms);
		// System.out.println(Mth.sum(powspect));

		// sine wave has rms of a/sqrt(2)
		Assert.assertEquals(1 / Math.sqrt(2), sampleRms, 0.001);
		// verify freq domain rms
		Assert.assertEquals(sampleRms, powRms, 0.001);
	}
}
