/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.seq;

import org.junit.Assert;
import org.junit.Test;

public class CombinationsTest {

	@Test
	public void test() {
		Combinations combinations = new Combinations();
		int[][] input = new int[][] { { 0, 1, 2 }, { 3, 4 }, { 5, 6 } };
		int[][] expanded = combinations.expand(input);
		Assert.assertEquals(12, expanded.length);
		int i = 0;
		Assert.assertArrayEquals(new int[] { 0, 3, 5 }, expanded[i++]);
		Assert.assertArrayEquals(new int[] { 1, 3, 5 }, expanded[i++]);
		Assert.assertArrayEquals(new int[] { 2, 3, 5 }, expanded[i++]);
		Assert.assertArrayEquals(new int[] { 0, 4, 5 }, expanded[i++]);
		Assert.assertArrayEquals(new int[] { 1, 4, 5 }, expanded[i++]);
		Assert.assertArrayEquals(new int[] { 2, 4, 5 }, expanded[i++]);
		Assert.assertArrayEquals(new int[] { 0, 3, 6 }, expanded[i++]);
		Assert.assertArrayEquals(new int[] { 1, 3, 6 }, expanded[i++]);
		Assert.assertArrayEquals(new int[] { 2, 3, 6 }, expanded[i++]);
		Assert.assertArrayEquals(new int[] { 0, 4, 6 }, expanded[i++]);
		Assert.assertArrayEquals(new int[] { 1, 4, 6 }, expanded[i++]);
		Assert.assertArrayEquals(new int[] { 2, 4, 6 }, expanded[i++]);
	}

	// @Test
	// public void testSearchKeyGen() {
	// HashSet<Integer> hs = new HashSet<Integer>();
	// hs.add(Integer.valueOf(4));
	// hs.add(Integer.valueOf(5));
	// hs.add(Integer.valueOf(7));
	// hs.add(Integer.valueOf(10));
	// hs.add(Integer.valueOf(13));
	// hs.add(Integer.valueOf(18));
	// LSHKeyGen h = new LSHKeyGen(hs, 1, 0.9, 1.1);
	// int[][] map = h.generateSearchKeys(new int[] { 5, 8 });
	// Assert.assertEquals(2, map.length);
	// Assert.assertTrue(Arrays.equals(new int[] { 0, 1, 2 }, map[0]));
	// Assert.assertTrue(Arrays.equals(new int[] { 2, 3 }, map[1]));
	// }

}
