/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.seq;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

public class MIteratorTest {

	@Test
	public void testIt() {

		MutatingStringIterator mi = new MutatingStringIterator(3);
		assertFalse(mi.hasNext());
		mi.insertRow(new char[] { 'a', '1', '\0' });
		assertFalse(mi.hasNext());
		mi.insertRow(new char[] { 'b', '\0', '\0' });
		assertFalse(mi.hasNext());
		mi.insertRow(new char[] { 'c', '2', '3' });
		assertTrue(mi.hasNext());
		assertEquals("abc", mi.next());
		assertEquals("1bc", mi.next());
		assertEquals("ab2", mi.next());
		assertEquals("1b2", mi.next());
		assertEquals("ab3", mi.next());
		assertEquals("1b3", mi.next());
		assertFalse(mi.hasNext());
		mi.insertRow(new char[] { 'A', 'B', '\0' });
		assertTrue(mi.hasNext());
		assertEquals("bcA", mi.next());
		assertEquals("b2A", mi.next());
		assertEquals("b3A", mi.next());
		assertEquals("bcB", mi.next());
		assertEquals("b2B", mi.next());
		assertEquals("b3B", mi.next());
		assertFalse(mi.hasNext());

	}
}
