/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.seq;

import junit.framework.Assert;

import org.junit.Test;

public class MutatingStringIteratorTest {

	@Test
	public void test1() {
		MutatingStringIterator msi = new MutatingStringIterator(6);
		msi.insertRow(new char[] { 'a' });
		msi.insertRow(new char[] { 'b' });
		msi.insertRow(new char[] { 'c' });
		msi.insertRow(new char[] { 'd' });
		msi.insertRow(new char[] { 'e' });
		Assert.assertFalse(msi.hasNext());
		msi.insertRow(new char[] { 'f' });
		Assert.assertTrue(msi.hasNext());
		Assert.assertEquals("abcdef", msi.next());
		Assert.assertFalse(msi.hasNext());
	}

	@Test
	public void test2() {
		MutatingStringIterator msi = new MutatingStringIterator(3);
		msi.insertRow(new char[] { 'a', 'b', 'c' });
		msi.insertRow(new char[] { 'd', 'e', 'f' });
		msi.insertRow(new char[] { 'g', 'h', 'i' });
		Assert.assertTrue(msi.hasNext());
		Assert.assertEquals("adg", msi.next());
		Assert.assertEquals("bdg", msi.next());
		Assert.assertEquals("cdg", msi.next());
		Assert.assertEquals("aeg", msi.next());
		Assert.assertEquals("beg", msi.next());
		Assert.assertEquals("ceg", msi.next());
		Assert.assertEquals("afg", msi.next());
		Assert.assertEquals("bfg", msi.next());
		Assert.assertEquals("cfg", msi.next());
		Assert.assertEquals("adh", msi.next());
		Assert.assertEquals("bdh", msi.next());
		Assert.assertEquals("cdh", msi.next());
		Assert.assertEquals("aeh", msi.next());
		Assert.assertEquals("beh", msi.next());
		Assert.assertEquals("ceh", msi.next());
		Assert.assertEquals("afh", msi.next());
		Assert.assertEquals("bfh", msi.next());
		Assert.assertEquals("cfh", msi.next());
		Assert.assertEquals("adi", msi.next());
		Assert.assertEquals("bdi", msi.next());
		Assert.assertEquals("cdi", msi.next());
		Assert.assertEquals("aei", msi.next());
		Assert.assertEquals("bei", msi.next());
		Assert.assertEquals("cei", msi.next());
		Assert.assertEquals("afi", msi.next());
		Assert.assertEquals("bfi", msi.next());
		Assert.assertEquals("cfi", msi.next());
		Assert.assertFalse(msi.hasNext());
		msi.insertRow(new char[] { 'j', 'k', 'l' });
		Assert.assertTrue(msi.hasNext());
		Assert.assertEquals("dgj", msi.next());
		Assert.assertEquals("egj", msi.next());
		Assert.assertEquals("fgj", msi.next());
		Assert.assertEquals("dhj", msi.next());
		Assert.assertEquals("ehj", msi.next());
		Assert.assertEquals("fhj", msi.next());
		Assert.assertEquals("dij", msi.next());
		Assert.assertEquals("eij", msi.next());
		Assert.assertEquals("fij", msi.next());
		Assert.assertEquals("dgk", msi.next());
		Assert.assertEquals("egk", msi.next());
		Assert.assertEquals("fgk", msi.next());
		Assert.assertEquals("dhk", msi.next());
		Assert.assertEquals("ehk", msi.next());
		Assert.assertEquals("fhk", msi.next());
		Assert.assertEquals("dik", msi.next());
		Assert.assertEquals("eik", msi.next());
		Assert.assertEquals("fik", msi.next());
		Assert.assertEquals("dgl", msi.next());
		Assert.assertEquals("egl", msi.next());
		Assert.assertEquals("fgl", msi.next());
		Assert.assertEquals("dhl", msi.next());
		Assert.assertEquals("ehl", msi.next());
		Assert.assertEquals("fhl", msi.next());
		Assert.assertEquals("dil", msi.next());
		Assert.assertEquals("eil", msi.next());
		Assert.assertEquals("fil", msi.next());
		Assert.assertFalse(msi.hasNext());
		msi.insertRow(new char[] { 'm', 'n', 'o' });
		Assert.assertTrue(msi.hasNext());
		Assert.assertEquals("gjm", msi.next());
		Assert.assertEquals("hjm", msi.next());
		Assert.assertEquals("ijm", msi.next());
		Assert.assertEquals("gkm", msi.next());
		Assert.assertEquals("hkm", msi.next());
		Assert.assertEquals("ikm", msi.next());
		Assert.assertEquals("glm", msi.next());
		Assert.assertEquals("hlm", msi.next());
		Assert.assertEquals("ilm", msi.next());
		Assert.assertEquals("gjn", msi.next());
		Assert.assertEquals("hjn", msi.next());
		Assert.assertEquals("ijn", msi.next());
		Assert.assertEquals("gkn", msi.next());
		Assert.assertEquals("hkn", msi.next());
		Assert.assertEquals("ikn", msi.next());
		Assert.assertEquals("gln", msi.next());
		Assert.assertEquals("hln", msi.next());
		Assert.assertEquals("iln", msi.next());
		Assert.assertEquals("gjo", msi.next());
		Assert.assertEquals("hjo", msi.next());
		Assert.assertEquals("ijo", msi.next());
		Assert.assertEquals("gko", msi.next());
		Assert.assertEquals("hko", msi.next());
		Assert.assertEquals("iko", msi.next());
		Assert.assertEquals("glo", msi.next());
		Assert.assertEquals("hlo", msi.next());
		Assert.assertEquals("ilo", msi.next());
		Assert.assertFalse(msi.hasNext());
		msi.insertRow(new char[] { 'p', 'q', 'r' });
		Assert.assertTrue(msi.hasNext());
		Assert.assertEquals("jmp", msi.next());
		Assert.assertEquals("kmp", msi.next());
		Assert.assertEquals("lmp", msi.next());
		Assert.assertEquals("jnp", msi.next());
		Assert.assertEquals("knp", msi.next());
		Assert.assertEquals("lnp", msi.next());
		Assert.assertEquals("jop", msi.next());
		Assert.assertEquals("kop", msi.next());
		Assert.assertEquals("lop", msi.next());
		Assert.assertEquals("jmq", msi.next());
		Assert.assertEquals("kmq", msi.next());
		Assert.assertEquals("lmq", msi.next());
		Assert.assertEquals("jnq", msi.next());
		Assert.assertEquals("knq", msi.next());
		Assert.assertEquals("lnq", msi.next());
		Assert.assertEquals("joq", msi.next());
		Assert.assertEquals("koq", msi.next());
		Assert.assertEquals("loq", msi.next());
		Assert.assertEquals("jmr", msi.next());
		Assert.assertEquals("kmr", msi.next());
		Assert.assertEquals("lmr", msi.next());
		Assert.assertEquals("jnr", msi.next());
		Assert.assertEquals("knr", msi.next());
		Assert.assertEquals("lnr", msi.next());
		Assert.assertEquals("jor", msi.next());
		Assert.assertEquals("kor", msi.next());
		Assert.assertEquals("lor", msi.next());
		Assert.assertFalse(msi.hasNext());
		msi.insertRow(new char[] { 's', 't', 'u' });
		Assert.assertTrue(msi.hasNext());
		Assert.assertEquals("mps", msi.next());
		Assert.assertEquals("nps", msi.next());
		Assert.assertEquals("ops", msi.next());
		Assert.assertEquals("mqs", msi.next());
		Assert.assertEquals("nqs", msi.next());
		Assert.assertEquals("oqs", msi.next());
		Assert.assertEquals("mrs", msi.next());
		Assert.assertEquals("nrs", msi.next());
		Assert.assertEquals("ors", msi.next());
		Assert.assertEquals("mpt", msi.next());
		Assert.assertEquals("npt", msi.next());
		Assert.assertEquals("opt", msi.next());
		Assert.assertEquals("mqt", msi.next());
		Assert.assertEquals("nqt", msi.next());
		Assert.assertEquals("oqt", msi.next());
		Assert.assertEquals("mrt", msi.next());
		Assert.assertEquals("nrt", msi.next());
		Assert.assertEquals("ort", msi.next());
		Assert.assertEquals("mpu", msi.next());
		Assert.assertEquals("npu", msi.next());
		Assert.assertEquals("opu", msi.next());
		Assert.assertEquals("mqu", msi.next());
		Assert.assertEquals("nqu", msi.next());
		Assert.assertEquals("oqu", msi.next());
		Assert.assertEquals("mru", msi.next());
		Assert.assertEquals("nru", msi.next());
		Assert.assertEquals("oru", msi.next());
		Assert.assertFalse(msi.hasNext());

	}
}
