/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.seq;

import junit.framework.Assert;

import org.jhears.web.rs.Segment;
import org.junit.Test;

public class SegmentIteratorTest {

	@Test
	public void test1() {
		SegmentIterator si = new SegmentIterator(3, "abc".toCharArray());
		Assert.assertTrue(si.hasNext());
		Assert.assertEquals("abc", si.next().getData());
		Assert.assertFalse(si.hasNext());
	}

	@Test
	public void test2() {
		SegmentIterator si = new SegmentIterator(3, "\\3abc\\3def\\3ghi\\3jkl"
				.toCharArray());
		Assert.assertTrue(si.hasNext());
		Assert.assertEquals("adg", si.next().getData());
		Assert.assertEquals("bdg", si.next().getData());
		Assert.assertEquals("cdg", si.next().getData());
		Assert.assertEquals("aeg", si.next().getData());
		Assert.assertEquals("beg", si.next().getData());
		Assert.assertEquals("ceg", si.next().getData());
		Assert.assertEquals("afg", si.next().getData());
		Assert.assertEquals("bfg", si.next().getData());
		Assert.assertEquals("cfg", si.next().getData());
		Assert.assertEquals("adh", si.next().getData());
		Assert.assertEquals("bdh", si.next().getData());
		Assert.assertEquals("cdh", si.next().getData());
		Assert.assertEquals("aeh", si.next().getData());
		Assert.assertEquals("beh", si.next().getData());
		Assert.assertEquals("ceh", si.next().getData());
		Assert.assertEquals("afh", si.next().getData());
		Assert.assertEquals("bfh", si.next().getData());
		Assert.assertEquals("cfh", si.next().getData());
		Assert.assertEquals("adi", si.next().getData());
		Assert.assertEquals("bdi", si.next().getData());
		Assert.assertEquals("cdi", si.next().getData());
		Assert.assertEquals("aei", si.next().getData());
		Assert.assertEquals("bei", si.next().getData());
		Assert.assertEquals("cei", si.next().getData());
		Assert.assertEquals("afi", si.next().getData());
		Assert.assertEquals("bfi", si.next().getData());
		Assert.assertEquals("cfi", si.next().getData());
		Assert.assertEquals("dgj", si.next().getData());
		Assert.assertEquals("egj", si.next().getData());
		Assert.assertEquals("fgj", si.next().getData());
		Assert.assertEquals("dhj", si.next().getData());
		Assert.assertEquals("ehj", si.next().getData());
		Assert.assertEquals("fhj", si.next().getData());
		Assert.assertEquals("dij", si.next().getData());
		Assert.assertEquals("eij", si.next().getData());
		Assert.assertEquals("fij", si.next().getData());
		Assert.assertEquals("dgk", si.next().getData());
		Assert.assertEquals("egk", si.next().getData());
		Assert.assertEquals("fgk", si.next().getData());
		Assert.assertEquals("dhk", si.next().getData());
		Assert.assertEquals("ehk", si.next().getData());
		Assert.assertEquals("fhk", si.next().getData());
		Assert.assertEquals("dik", si.next().getData());
		Assert.assertEquals("eik", si.next().getData());
		Assert.assertEquals("fik", si.next().getData());
		Assert.assertEquals("dgl", si.next().getData());
		Assert.assertEquals("egl", si.next().getData());
		Assert.assertEquals("fgl", si.next().getData());
		Assert.assertEquals("dhl", si.next().getData());
		Assert.assertEquals("ehl", si.next().getData());
		Assert.assertEquals("fhl", si.next().getData());
		Assert.assertEquals("dil", si.next().getData());
		Assert.assertEquals("eil", si.next().getData());
		Assert.assertEquals("fil", si.next().getData());
		Assert.assertFalse(si.hasNext());
	}

	@Test
	public void test3() {
		SegmentIterator si = new SegmentIterator(3, "\\3abc\\3def\\3ghi\\3jkl"
				.toCharArray());
		Assert.assertTrue(si.hasNext());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(0, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertEquals(1, si.next().getPosition());
		Assert.assertFalse(si.hasNext());
	}

	@Test
	public void test4() {
		SegmentIterator si = new SegmentIterator(3, "abc\\2XYdef".toCharArray());
		Assert.assertTrue(si.hasNext());
		Segment s = si.next();
		Assert.assertEquals(0, s.getPosition());
		Assert.assertEquals("abc", s.getData());
		s = si.next();
		Assert.assertEquals(1, s.getPosition());
		Assert.assertEquals("bcX", s.getData());
		s = si.next();
		Assert.assertEquals(1, s.getPosition());
		Assert.assertEquals("bcY", s.getData());
		s = si.next();
		Assert.assertEquals(2, s.getPosition());
		Assert.assertEquals("cXd", s.getData());
		s = si.next();
		Assert.assertEquals(2, s.getPosition());
		Assert.assertEquals("cYd", s.getData());
		s = si.next();
		Assert.assertEquals(3, s.getPosition());
		Assert.assertEquals("Xde", s.getData());
		s = si.next();
		Assert.assertEquals(3, s.getPosition());
		Assert.assertEquals("Yde", s.getData());
		s = si.next();
		Assert.assertEquals(4, s.getPosition());
		Assert.assertEquals("def", s.getData());
		Assert.assertFalse(si.hasNext());
	}

	@Test
	public void test5() {
		SegmentIterator si = new SegmentIterator(3, "abcdefg".toCharArray());
		Assert.assertTrue(si.hasNext());
		Segment s;
		s = si.next();
		Assert.assertEquals(0, s.getPosition());
		Assert.assertEquals("abc", s.getData());
		s = si.next();
		Assert.assertEquals(1, s.getPosition());
		Assert.assertEquals("bcd", s.getData());
		s = si.next();
		Assert.assertEquals(2, s.getPosition());
		Assert.assertEquals("cde", s.getData());
		s = si.next();
		Assert.assertEquals(3, s.getPosition());
		Assert.assertEquals("def", s.getData());
		s = si.next();
		Assert.assertEquals(4, s.getPosition());
		Assert.assertEquals("efg", s.getData());
		Assert.assertFalse(si.hasNext());
	}

	@Test
	public void test6() {
		SegmentIterator si = new SegmentIterator(5, "abcd".toCharArray());
		Assert.assertFalse(si.hasNext());
	}
}
