/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.serialization;

import java.nio.ByteBuffer;
import java.util.Random;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class CharSerializationTest {

	private static final int LEN = 64;
	private byte[] expectedBytes;
	private char[] expectedChars;

	@Before
	public void before() {
		Random r = new Random(0);
		expectedBytes = new byte[LEN];
		r.nextBytes(expectedBytes);
		expectedChars = new char[LEN / 2];
		ByteBuffer.wrap(expectedBytes).asCharBuffer().get(expectedChars);
	}

	@Test
	public void testToByteArray() {
		byte[] actual = CharSerialization.toByteArray(expectedChars);
		Assert.assertArrayEquals(expectedBytes, actual);
	}

	@Test
	public void testToCharArray() {
		char[] actual = CharSerialization.toCharArray(expectedBytes);
		Assert.assertArrayEquals(expectedChars, actual);
	}

}
