/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.data;

import java.io.Serializable;
import java.util.List;

public interface IGenericDao {

	long count(Class<?> clazz);

	<T> List<T> list(Class<T> clazz, int first, int count, String propertyName,
			boolean ascending);

	<T> List<T> list(Class<T> clazz, int first, int count);

	<T> T get(Class<T> clazz, Serializable id);

	<T> T get(Class<T> clazz, String propertyName, Object propertyValue);

	long count(Class<?> clazz, String propertyName, Object propertyValue);

	<T> boolean delete(Class<T> clazz, Serializable id);

	Serializable save(Object object);

	void update(Object object);

}
