/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.data;

import org.hibernate.HibernateException;
import org.hibernate.Session;

public interface SessionProvider {

	/**
	 * Returns a new open hiberante session.
	 * 
	 * @return
	 * @throws HibernateException
	 */
	public Session openSession() throws HibernateException;

	/**
	 * Returns jdbc batch size if available. This method is optional and returns
	 * -1 if batch size is not available.
	 * 
	 * @return
	 */
	public int getJdbcBatchSize();

}
