/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.data;

import java.io.File;
import java.io.IOException;

import org.jhears.util.DefaultHashFunction;
import org.jhears.util.HashFunction;
import org.jhears.util.Serialization;
import org.jhears.util.Serializer;
import org.junit.After;
import org.junit.Before;
import org.junit.Rule;
import org.junit.rules.TemporaryFolder;

public class BerkeleyMapTest extends DatabaseMapTest {

	private BerkeleyMapManager ee;
	private Serialization serialization;
	private HashFunction<String> hashFunction;

	@Rule
	public TemporaryFolder folder = new TemporaryFolder();

	// @BeforeClass
	// public static void beforeClass() {
	// JulSlf4jBridge.install();
	// }

	@Before
	public void before() throws IOException {
		File envHome = folder.newFolder("dbTest");
		envHome.mkdirs();
		ee = new BerkeleyMapManager(envHome);
		serialization = new Serializer();
		hashFunction = new DefaultHashFunction<String>();
	}

	@After
	public void after() {
		ee.shutDown();
	}

	@Override
	protected DatabaseMap<String, String> createMap() {
		String name = Integer.toString(ThreadId.get());
		return new BerkeleyMap<String, String>(ee, name, null, serialization,
				hashFunction);
	}
}
