/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.data;

import java.io.IOException;

import org.jhears.util.DefaultHashFunction;
import org.jhears.util.HashFunction;
import org.jhears.util.Serialization;
import org.jhears.util.Serializer;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;

public class HibernateMapTest extends DatabaseMapTest {

	private HibernateMapManager manager;
	private Serialization serialization;
	private HashFunction<String> hashFunction;

	private static SessionProvider sp;

	private DAO dao;

	@BeforeClass
	public static void beforeClass() {
		sp = new HibernateSessionProvider();
	}

	@AfterClass
	public static void afterClass() {

	}

	@Before
	public void before() throws IOException {
		dao = new DAO(sp);
		serialization = new Serializer();
		manager = new HibernateMapManager(dao, serialization);
		hashFunction = new DefaultHashFunction<String>();
	}

	@After
	public void after() {

	}

	@Override
	protected DatabaseMap<String, String> createMap() {
		DatabaseMap<String, String> m = manager.getMap(Integer
				.toString(ThreadId.get()), serialization, hashFunction);
		if (m == null) {
			m = manager.createMap(Integer.toString(ThreadId.get()),
					hashFunction);
		}
		return m;

	}
}
