/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.data;

import java.nio.ByteBuffer;

import org.junit.Assert;
import org.junit.Test;

public class LongUtilTest {

	@Test
	public void testMakeBytes() {
		for (long value : new long[] { 0, 1, 2, -1, -2, 0x1234567890L }) {
			byte[] buf = new byte[8];
			ByteBuffer.wrap(buf).asLongBuffer().put(value);
			Assert.assertArrayEquals(buf, LongUtil.makeBytes(value));
		}
	}

	@Test
	public void testMakeLong() {
		for (long value : new long[] { 0, 1, 2, -1, -2, 0x1234567890L }) {
			byte[] buf = new byte[8];
			ByteBuffer.wrap(buf).asLongBuffer().put(value);
			Assert.assertEquals(value, LongUtil.makeLong(buf));
		}
	}

}
