/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.server;

import org.jhears.web.rs.AudioEntity;
import org.jhears.web.rs.Fingerprint;
import org.jhears.web.rs.SearchResult;

public interface FingerprintStorage {

	boolean deleteAudioEntity(String audioEntityId, ICtx ctx);

	boolean deleteFingerprint(String fingerprintId, ICtx ctx);

	AudioEntity getAudioEntity(String audioEntityId, ICtx ctx);

	Fingerprint getFingerprint(String fingerprintId, ICtx ctx);

	Fingerprint insertFingerprint(String audioEntityId, String fingerprintData,
			ICtx ctx);

	SearchResult[] search(String fingerprintData, ICtx ctx);

	/**
	 * Return true if approve was successful, false if approve was rejected or
	 * null if fingerprint was not found.
	 * 
	 * @param identifer
	 * @param ctx
	 * @return
	 */
	Boolean approveFingerprint(String fingerprintId, ICtx ctx);

}
