/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.server.tool;

import java.util.List;

import org.jhears.seq.ISmoother;
import org.jhears.seq.RLEnc;
import org.jhears.web.rs.Repeat;

public class RepeatProducer {

	private final RLEnc enc;

	private final ISmoother smoother;

	public RepeatProducer(RLEnc enc, ISmoother smoother) {
		this.smoother = smoother;
		this.enc = enc;
	}

	public List<Repeat> toRepeats(String fingerprint) {
		char[] ca = fingerprint.toCharArray();
		smoother.smooth(ca);
		return enc.encode(ca);
	}

}
