/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.web.rs;

import java.util.Map;

import javax.ws.rs.DefaultValue;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;

@Path(ApiPath.GET_CONFIGURATION + "/{name}")
public class ConfigurationResource extends BaseResource {

	public ConfigurationResource(BaseResourceParam param) {
		super(param);
	}

	@GET
	@Produces(value = { MediaType.APPLICATION_JSON, MediaType.TEXT_PLAIN })
	public Response process(@PathParam("name") String confName,
			@DefaultValue("json") @QueryParam("format") Format format) {
		// if (!isAuthorized(Const.USER)) {
		// return unauthorized();
		// }

		Map<String, Object> cMap = getCatalog().getConfMap(confName);
		if (cMap != null) {
			if (Format.plain.equals(format)) {
				return Response.ok(toText(cMap), MediaType.TEXT_PLAIN).build();
			} else {
				return Response.ok(cMap, MediaType.APPLICATION_JSON).build();
			}
		}
		return Response.status(Status.NOT_FOUND).build();
	}

}
