/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.util;

import java.io.Serializable;
import java.util.Arrays;

/**
 * Wrapper for java primitive type char[].
 */
public class CharArr implements Serializable {

	private static final long serialVersionUID = -4474355845723723508L;

	private final char[] charArr;

	public CharArr(final char[] charArr) {
		this.charArr = charArr;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		CharArr other = (CharArr) obj;
		if (!Arrays.equals(charArr, other.charArr))
			return false;
		return true;
	}

	public char[] getCharArr() {
		return charArr;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + Arrays.hashCode(charArr);
		return result;
	}

	@Override
	public String toString() {
		return CharArr.class.getSimpleName() + " [charArr="
				+ Arrays.toString(charArr) + "]";
	}

}