/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.util;

import org.junit.Assert;
import org.junit.Test;

public class MthTest {

	@Test
	public void f() {
		double[] primes = new double[] { 7, 11, 13, 17, 19, 23, 29 };

		Assert.assertEquals(Mth.mean(primes),
				Mth.mean(primes, 0, primes.length), 0.0);

		Assert.assertEquals((11 + 13 + 17 + 19 + 23) / 5.0,
				Mth.mean(primes, 1, primes.length - 1), 0.0);
		Assert.assertEquals((11 + 13 + 17 + 19) / 4.0,
				Mth.mean(primes, 1, primes.length - 2), 0.0);
	}
}
