/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * 
 */
package org.apache.wicket.contrib.recaptcha;

import java.util.List;

public class ReCaptchaException extends Exception {

	private static final long serialVersionUID = 1L;

	private final List<String> reply;

	public ReCaptchaException(String message, List<String> reply) {
		super(message + ", reply=" + reply);
		this.reply = reply;
	}

	/**
	 * Lines returned by the reCaptcha server. see
	 * http://recaptcha.net/apidocs/captcha/
	 * 
	 * @return
	 */
	public List<String> getReply() {
		return reply;
	}

}