/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.webgui.pages.admin;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.form.Button;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.TextField;
import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.model.PropertyModel;
import org.jhears.data.IGenericDao;
import org.jhears.data.UserDataObj;
import org.jhears.webgui.pages.TemplatePage;
import org.jhears.webgui.util.EntityModel;


import com.google.inject.Inject;

public class AddPersonPage extends AdminTemplatePage {

	@Inject
	private IGenericDao dao;

	public AddPersonPage(final WebPage previous) {
		super();

		setPageTitle("Add person");
		EntityModel<UserDataObj> modelnew = new EntityModel<UserDataObj>(new UserDataObj());
		final CompoundPropertyModel<UserDataObj> m = new CompoundPropertyModel<UserDataObj>(
				modelnew);
		Form<UserDataObj> form = new Form<UserDataObj>("addForm", m);
		form.add(new TextField<UserDataObj>("name", new PropertyModel<UserDataObj>(m
				.getObject(), "name")));

		Button addButton = new Button("add") {
			@Override
			public void onSubmit() {
				dao.save(m.getObject());
				setResponsePage(previous);
			}
		};
		form.add(addButton);

		Button cancelButton = new Button("cancel") {
			@Override
			public void onSubmit() {
				setResponsePage(previous);
			}
		};
		form.add(cancelButton);
		add(form);
	}
}