/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * 
 */
package org.jhears.webgui.pages.header;

import org.apache.wicket.Session;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.html.panel.Panel;
import org.jhears.webgui.WebguiAuthenticatedWebSession;
import org.jhears.webgui.pages.HomePage;
import org.jhears.webgui.pages.login.LoginPage;
import org.jhears.webgui.pages.login.LogoutPage;
import org.jhears.webgui.pages.register.RegisterPage;

public class DefaultPanel extends Panel {

	private static final long serialVersionUID = 1L;

	public DefaultPanel(String id) {
		super(id);
		Link<RegisterPage> register = new Link<RegisterPage>("register") {

			private static final long serialVersionUID = 1L;

			@Override
			public void onClick() {
				setResponsePage(RegisterPage.class);
			}
		};

		Link<LogoutPage> logout = new Link<LogoutPage>("logout") {

			private static final long serialVersionUID = 1L;

			@Override
			public void onClick() {
				setResponsePage(LogoutPage.class);
			}
		};

		Link<LoginPage> login = new Link<LoginPage>("login") {

			private static final long serialVersionUID = 1L;

			@Override
			public void onClick() {
				setResponsePage(LoginPage.class);
			}
		};
		if (((WebguiAuthenticatedWebSession) Session.get()).isSignedIn()) {
			login.setVisible(false);
			register.setVisible(false);
		} else {
			logout.setVisible(false);

		}

		add(register);
		add(logout);
		add(login);

		add(new Link<HomePage>("homePage") {

			private static final long serialVersionUID = 1L;

			@Override
			public void onClick() {
				setResponsePage(HomePage.class);
			}
		});

	}

}