/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * 
 */
package org.jhears.webgui.pages.header;

import org.apache.wicket.authorization.Action;
import org.apache.wicket.authorization.strategies.role.annotations.AuthorizeAction;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.html.panel.Panel;
import org.jhears.auth.JHearsRoles;
import org.jhears.webgui.pages.user.PersonalAccountPage;

@AuthorizeAction(action = Action.RENDER, roles = JHearsRoles.USER)
public class UserPanel extends Panel {

	private static final long serialVersionUID = 1L;

	public UserPanel(String id) {
		super(id);
		Link<PersonalAccountPage> myAccount = new Link<PersonalAccountPage>(
				"myAccount") {

			private static final long serialVersionUID = 1L;

			@Override
			public void onClick() {
				setResponsePage(PersonalAccountPage.class);
			}
		};

		add(myAccount);
	}

}