/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.webgui.pages.login;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;

import org.apache.wicket.Application;
import org.apache.wicket.authentication.pages.SignOutPage;
import org.apache.wicket.markup.html.link.Link;
import org.jhears.webgui.WicketApplication;
import org.jhears.webgui.pages.HomePage;

import com.google.common.base.Throwables;

public class LogoutPage extends SignOutPage {

	public LogoutPage() {
		super();

		add(new Link<HomePage>("home") {

			private static final long serialVersionUID = 1L;

			@Override
			public void onClick() {
				HttpServletRequest req = getWebRequestCycle().getWebRequest()
						.getHttpServletRequest();
				RequestDispatcher dispatcher = req
				.getRequestDispatcher(((WicketApplication) Application
						.get()).getLoginServlet());

				HttpServletRequestParamble request = new HttpServletRequestParamble(req);
				request.addParam("logout", "true");
				request.addParam("redirectOnSuccess",
						((WicketApplication) Application.get())
								.getLogoutRedirect());
				request.addParam("redirectOnFailure",
						((WicketApplication) Application.get())
								.getLogoutRedirect());

				try {
					dispatcher.forward(request, getWebRequestCycle()
							.getWebResponse().getHttpServletResponse());
				} catch (ServletException e) {
					throw Throwables.propagate(e);
				} catch (IOException e) {
					throw Throwables.propagate(e);
				}
				// stop wicket page processing
				getWebRequestCycle().setRequestTarget(null);

			}
		});
	}

}
