/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.webgui.pages.simple;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.Button;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.model.CompoundPropertyModel;
import org.jhears.data.IGenericDao;
import org.jhears.data.UserDataObj;
import org.jhears.webgui.pages.TemplatePage;
import org.jhears.webgui.util.EntityModel;

import com.google.inject.Inject;

public class LockAccountPage extends TemplatePage {

	public LockAccountPage(UserDataObj person, final WebPage previous) {
		super();
		setPageTitle("Confirm delete person");
		EntityModel<UserDataObj> modelnew = new EntityModel<UserDataObj>(person);
		final CompoundPropertyModel<UserDataObj> m = new CompoundPropertyModel<UserDataObj>(
				modelnew);
		Form<UserDataObj> form = new Form<UserDataObj>("editForm", m);
		add(new Label("name", person.getName()));

		Button deleteButton = new Button("delete") {

			private static final long serialVersionUID = 1L;
			@Inject
			private IGenericDao dao;

			@Override
			public void onSubmit() {
				dao.delete(UserDataObj.class, m.getObject().getId());
				setResponsePage(previous);
			}
		};
		form.add(deleteButton);

		Button cancelButton = new Button("cancel") {
			private static final long serialVersionUID = 1L;

			@Override
			public void onSubmit() {
				setResponsePage(previous);
			}
		};
		form.add(cancelButton);
		add(form);
	}
}