/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.jhears.webgui.pages.user;

import org.apache.wicket.markup.html.link.Link;
import org.jhears.webgui.pages.HomePage;
import org.jhears.webgui.pages.simple.ChangeAccountPasswordPage;
import org.jhears.webgui.pages.simple.LockAccountPage;

public class PersonalAccountPage extends UserTemplatePage {

	private static final long serialVersionUID = 1L;

	public PersonalAccountPage() {

		setPageTitle("Personal settings");

		add(new Link<HomePage>("changePassword") {

			private static final long serialVersionUID = 1L;

			@Override
			public void onClick() {
				setResponsePage(ChangeAccountPasswordPage.class);
			}

		});

		add(new Link<HomePage>("deleteAccount") {

			private static final long serialVersionUID = 1L;

			@Override
			public void onClick() {
				setResponsePage(DeleteAccountPage.class);
			}
		});

		add(new Link<HomePage>("lockAccount") {

			private static final long serialVersionUID = 1L;

			@Override
			public void onClick() {
				setResponsePage(LockAccountPage.class);
			}
		});

	}

}
