/*
 * jHears, acoustic fingerprinting framework.
 * Copyright (C) 2009-2010  Juha Heljoranta.
 *
 * This file is part of jHears.
 *
 * jHears is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * jHears is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with jHears.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * 
 */
package org.jhears.webgui.util;

import java.util.Iterator;

import org.apache.wicket.extensions.markup.html.repeater.util.SortParam;
import org.apache.wicket.extensions.markup.html.repeater.util.SortableDataProvider;
import org.apache.wicket.model.IModel;
import org.jhears.util.Identifiable;

public class SortableGenericDataProvider<T extends Identifiable<?>> extends
		SortableDataProvider<T> {

	private static final long serialVersionUID = 1L;

	private final GenericDataProvider<T> provider;

	public SortableGenericDataProvider(GenericDataProvider<T> provider) {
		this.provider = provider;
	}

	@Override
	public Iterator<? extends T> iterator(int first, int count) {
		SortParam sp = getSort();
		if (sp != null) {
			String property = sp.getProperty();
			boolean ascending = sp.isAscending();
			return provider.iterator(first, count, property, ascending);
		} else {
			return provider.iterator(first, count);
		}
	}

	@Override
	public IModel<T> model(T object) {
		return provider.model(object);
	}

	@Override
	public int size() {
		return provider.size();
	}

}